#include "../w95k.h"

int ProcessKey(MPARAM mp1, MPARAM mp2)
{ int Flags;
  unsigned char Repeat;
  unsigned char ScanCode;
  unsigned char Character;
  int VirtualKey;
  
  struct Event e, *pe;
  ULONG p;
  TID tidFoo;

  
  Flags=SHORT1FROMMP(mp1);
  Repeat=CHAR3FROMMP(mp1);
  ScanCode=CHAR4FROMMP(mp1);
  Character=(SHORT1FROMMP(mp2)) &0xFF;
  VirtualKey=SHORT2FROMMP(mp2);

  /*Process as modifier*/
  ModifierSet(ScanCode, Flags);
  
  
  /*Try to find appropriate event*/
  
  if(EventFindFoo(ScanCode, Flags, &e)==0)
    { /*Found*/
      if((Flags & KC_KEYUP) && /*Run event only if key was released */
         (Flags & KC_LONEKEY)) /*And no other keys was used         */
        { pe=malloc(sizeof(struct Event));
          if(pe==NULL)
            { 
              return(-1);
            }
          memcpy(pe, &e, sizeof(struct Event));
          p=(ULONG)pe;
          DosCreateThread(&tidFoo, (PFNTHREAD)EventStart, p, 0, 65535);
          
        }
        
      return(0); /* Remove event */
    }

  return(1);
}

VOID APIENTRY EventStart(ULONG p)
{ struct Event * e=(struct Event *) p;

  e->Foo(e->Parameters.argc, e->Parameters.argv);
  free(e);

}




