#include "../w95k.h"


int w95kStartup(int loadPars)
{ int a;

  if(ProfileOpen()!=0)
    { WinPerror("Can't initialize", "Can't open profile");
      return(-1);
    }

  if(ModifierInit()!=0)
    { WinPerror("Can't initialize", "Can't initialize modifiers");
      ProfileClose();
      return(-1);
    }
    
  if(PluginInit()!=0)
    { WinPerror("Can't initialize", "Can't initialize plugins");
      ModifierFree();
      ProfileClose();
      return(-1);
    }

  if(EventInit()!=0)
    { WinPerror("Can't initialize", "Can't initialize events");
      PluginFree();
      ModifierFree();
      ProfileClose();
      return(-1);
    }

  if(HookSet()!=0)
    { WinPerror("Can't initialize", "Can't register hook");
      PluginFree();
      ModifierFree();
      ProfileClose();
      return(-1);
    }
    
  ProfileClose();

  return(0);
}

int w95kShutdown(int savePars)
{ if(savePars)
    { if(ProfileOpen()==0)
        { ProfileSaveParams();
          ProfileClose();
        }
    }

  HookRemove();

  ModifierFree();
  PluginFree();
  EventFree();
  
  return(0);
}


